import java.awt.*;
import java.awt.event.*;
import java.util.*;

class MediatorDemoView extends SCView {

	/**
	 *  WidgetMediator will act as the Mediator for all widgets.
	 */
	private WidgetMediator widgetMediator_;
	private WidgetMediator widgetMediator() { return widgetMediator_; }
	private void widgetMediator( WidgetMediator aWidgetMediator ) { widgetMediator_ = aWidgetMediator; }

    MediatorDemoView(){
        super("Mediator Demo View");
        this.initialize();
    }

    public static void main(String argv[]){
        MediatorDemoView theMediatorDemoView = new MediatorDemoView();
        theMediatorDemoView.show();
    }

    private void initialize(){

        this.setLayout(null);

        this.initMenu();

        this.widgetMediator(new WidgetMediator(this));

        this.initWidgets();

        this.setSize(450,360);
        this.setLocation(80,80);

    }
    private void initWidgets(){
        NickelButton nb = new NickelButton(this.widgetMediator());
        this.add(nb);
        this.widgetMediator().addWidget("nickel Button",nb);

        ShadowButton sb = new ShadowButton(this.widgetMediator());
        this.add(sb);
        this.widgetMediator().addWidget("shadow Button", sb);

        TypeInMeTextField timtf = new TypeInMeTextField(this.widgetMediator());
        this.add(timtf);
        this.widgetMediator().addWidget("type in me TextField",timtf);

        TheOnlyLabel tol = new TheOnlyLabel();
        this.add(tol);
        this.widgetMediator().addWidget("the only Label", tol);

    }
    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();


            Menu aMenu = new Menu("File");
                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
            aMenu.add(aMenuItem);

        aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);
    }
   public void actionPerformed(ActionEvent e){
        String actionCommand = e.getActionCommand();
        if( actionCommand.equals("Exit") ){
            this.exit();
            return;
        }
    }


    public void windowClosing(WindowEvent we){
        this.exit();
    }
    private void exit(){
        System.out.println("closing MediatorDemoView");
        try{ Thread.sleep(500); }
        catch(InterruptedException ie){}
        this.dispose();
        System.exit(0);
    }




}

